Index: Doxyfile.regfi
===================================================================
--- Doxyfile.regfi	(revision 209)
+++ Doxyfile.regfi	(revision 210)
@@ -26,5 +26,5 @@
 # by quotes) that should identify the project.
 
-PROJECT_NAME           = reglookup
+PROJECT_NAME           = regfi
 
 # The PROJECT_NUMBER tag can be used to enter a project or revision number.
@@ -215,5 +215,6 @@
 # Objective-C, Python, Fortran, VHDL, C, C++. For instance to make doxygen treat
 # .inc files as Fortran files (default is PHP), and .f files as C (default is Fortran),
-# use: inc=Fortran f=C. Note that for custom extensions you also need to set FILE_PATTERNS otherwise the files are not read by doxygen.
+# use: inc=Fortran f=C. Note that for custom extensions you also need to set
+# FILE_PATTERNS otherwise the files are not read by doxygen.
 
 EXTENSION_MAPPING      =
@@ -412,5 +413,11 @@
 SORT_BRIEF_DOCS        = NO
 
-# If the SORT_MEMBERS_CTORS_1ST tag is set to YES then doxygen will sort the (brief and detailed) documentation of class members so that constructors and destructors are listed first. If set to NO (the default) the constructors will appear in the respective orders defined by SORT_MEMBER_DOCS and SORT_BRIEF_DOCS. This tag will be ignored for brief docs if SORT_BRIEF_DOCS is set to NO and ignored for detailed docs if SORT_MEMBER_DOCS is set to NO.
+# If the SORT_MEMBERS_CTORS_1ST tag is set to YES then doxygen will sort
+# the (brief and detailed) documentation of class members so that constructors
+# and destructors are listed first. If set to NO (the default) the
+# constructors will appear in the respective orders defined by
+# SORT_MEMBER_DOCS and SORT_BRIEF_DOCS. This tag will be ignored for brief
+# docs if SORT_BRIEF_DOCS is set to NO and ignored for detailed docs if
+# SORT_MEMBER_DOCS is set to NO.
 
 SORT_MEMBERS_CTORS_1ST = NO
@@ -575,5 +582,5 @@
 # with spaces.
 
-INPUT                  = trunk/lib trunk/include
+INPUT                  = trunk/lib trunk/include trunk/python/pyregfi
 
 # This tag can be used to specify the character encoding of the source files
@@ -831,5 +838,6 @@
 # ~/Library/Developer/Shared/Documentation/DocSets so that Xcode will find
 # it at startup.
-# See http://developer.apple.com/tools/creatingdocsetswithdoxygen.html for more information.
+# See http://developer.apple.com/tools/creatingdocsetswithdoxygen.html for
+# more information.
 
 GENERATE_DOCSET        = NO
@@ -924,5 +932,6 @@
 QHP_CUST_FILTER_NAME   =
 
-# The QHP_CUST_FILT_ATTRS tag specifies the list of the attributes of the custom filter to add.For more information please see
+# The QHP_CUST_FILT_ATTRS tag specifies the list of the attributes of the
+# custom filter to add.For more information please see
 # <a href="http://doc.trolltech.com/qthelpproject.html#custom-filters">Qt Help Project / Custom Filters</a>.
 
@@ -948,5 +957,6 @@
 # files needs to be copied into the plugins directory of eclipse. The name of
 # the directory within the plugins directory should be the same as
-# the ECLIPSE_DOC_ID value. After copying Eclipse needs to be restarted before the help appears.
+# the ECLIPSE_DOC_ID value. After copying Eclipse needs to be restarted
+# before the help appears.
 
 GENERATE_ECLIPSEHELP   = NO
@@ -998,6 +1008,9 @@
 FORMULA_FONTSIZE       = 10
 
-# When the SEARCHENGINE tag is enabled doxygen will generate a search box for the HTML output. The underlying search engine uses javascript
-# and DHTML and should work on any modern browser. Note that when using HTML help (GENERATE_HTMLHELP), Qt help (GENERATE_QHP), or docsets (GENERATE_DOCSET) there is already a search function so this one should
+# When the SEARCHENGINE tag is enabled doxygen will generate a search box
+# for the HTML output. The underlying search engine uses javascript
+# and DHTML and should work on any modern browser. Note that when using HTML
+# help (GENERATE_HTMLHELP), Qt help (GENERATE_QHP), or docsets (GENERATE_DOCSET)
+# there is already a search function so this one should
 # typically be disabled. For large projects the javascript based search engine
 # can be slow, then enabling SERVER_BASED_SEARCH may provide a better solution.
@@ -1005,6 +1018,10 @@
 SEARCHENGINE           = YES
 
-# When the SERVER_BASED_SEARCH tag is enabled the search engine will be implemented using a PHP enabled web server instead of at the web client using Javascript. Doxygen will generate the search PHP script and index
-# file to put on the web server. The advantage of the server based approach is that it scales better to large projects and allows full text search. The disadvances is that it is more difficult to setup
+# When the SERVER_BASED_SEARCH tag is enabled the search engine will be 
+# implemented using a PHP enabled web server instead of at the web client using
+# Javascript. Doxygen will generate the search PHP script and index
+# file to put on the web server. The advantage of the server based approach is 
+# that it scales better to large projects and allows full text search. The 
+# disadvances is that it is more difficult to setup
 # and does not have live searching capabilities.
 
@@ -1090,5 +1107,7 @@
 LATEX_HIDE_INDICES     = NO
 
-# If LATEX_SOURCE_CODE is set to YES then doxygen will include source code with syntax highlighting in the LaTeX output. Note that which sources are shown also depends on other settings such as SOURCE_BROWSER.
+# If LATEX_SOURCE_CODE is set to YES then doxygen will include source code 
+# with syntax highlighting in the LaTeX output. Note that which sources are
+# shown also depends on other settings such as SOURCE_BROWSER.
 
 LATEX_SOURCE_CODE      = NO
@@ -1338,5 +1357,5 @@
 # a tag file that is based on the input files it reads.
 
-GENERATE_TAGFILE       =
+GENERATE_TAGFILE       = doc/regfi/regfi.tags
 
 # If the ALLEXTERNALS tag is set to YES all external classes will be listed